<html>
<body>
<h1> 2. schematics data </h1>

<p>{des2:0}
This chapter is an overview of the data model cschem uses. Some details, e.g.
<a href="04_attrib.html">attributes</a>, <a href="03_drawing.html"> drawing primitives</a> or
<a href="06_hierarchy.html">hierarchic design</a> will be discussed in later
chapters.

<h2> 2.1. Projects </h2>

<p>{des2:1}
A project is a collection of schematics sheets, data files, configuration,
pcb-files, local libraries, logs, etc. What content belongs to a project
shall be decided by the user.

<p>{des2:2}
The tool-agnostic project file describes the project by having tool-specific
sections.

<p>{des2:3}
The cschem-specific section of the project file consists of a list of files
that are relevant to cschem:
<ul>
	<li> view configuration
	<li> plugin configuration, per view
	<li> local lib configuration
	<li> references to the schematic sheet(s)
	<li> per-tool configuration, e.g. GUI-related settings for the graphical
	     schematics editor (optionally per view)
</ul>

<p>{des2:4} <a id="des2:4">
A schematics sheet consists of <i>concrete</i> elements (e.g. drawing
primitives, attributes, data) that indirectly describe <i>abstract</i> schematics objects.
The user is able to manipulate the <i>concrete</i> elements only, but can also
see the <i>abstract</i> objects. Much of cschem deals with the <i>abstract</i>
objects.

<p>{des2:5}
Each schematics sheet has a cschem generated unique ID and user specified
attributes. Both the unique ID and attributes of the graphical sheet
are stored in the <a href="03_drawing.html#des3:66">direct subtree</a> of
the sheet.

<p>{des2:68} <a id="des2:68">
The following diagram shows how concrete graphical schematics sheet
elements can affect objects in the abstract model:

<p><img src="02_graphical.svg">

<p>{des2:69} Note 1: concrete object attributes can affect the abstract model
by making connections and creating new networks.

<p>{des2:73} Note 2: a connection drawing primitive contributes to the
"list of terminals" of wire-nets and bus-nets.

<p>{des2:74} Note 3: groups also donate the attributes on their outgoing arrow;
these then become the attribute of concrete objects and as a side effect
(blue lines) may affect networks.



<h2> 2.2. <i>Abstract:</i> schematics objects </h2>

<p>{des2:6}
On an abstract logical level, a schematic consist of <i>components</i>
that have <i>ports</i>, and named <i>networks</i> that connect those
ports. <i>Networks</i> can be bundled into <i>buses</i> and <i>buses</i>
can be connected to <i>bus-ports</i>. <i>Networks</i> can be split and
connected by <i>hubs</i>.

<p>{des2:7}
In an electronic example a <i>component</i>  is a NAND gate, a
<i>port</i> is a pin or pad or terminal of the gate and <i>network</i> is
the electrical connection between the <i>port</i> of the gate and other
<i>ports</i> in the circuit.

<p>{des2:56}
Each <a href="01_system.html#des1:21">view</a> has its own <i>abstract</i>
object model, generated by different set of plugins with different
configuration from the same <i>concrete</i> model. Since views are
independent, the per view <i>abstract</i> models are independent too.
The <i>abstract</i> models are generated on the fly and are not saved.

<p>{des2:75} <a id="des2:75">
An abstract schematics object always contains a list of concrete-object 
(or concrete-object:key)
pairs referring to any concrete object (or an attribute of a concrete
object in the latter case) that contributed to the abstract object. This
cross-reference lets the user track back the sources of an abstract object,
which is important because the final output (e.g. netlist) is generated
from the abstract objects while the user can make changes to the
concrete objects only.


<h2> 2.3. <i>Concrete:</i> graphical schematics sheets </h2>

<p>{des2:8}
A graphical schematics sheet is a two dimensional drawing, consisting of:
<ul>
	<li> symbols - explicit (graphical)
	<li> network connections - explicit (graphical) and implicit (attribute)
	<li> decoration
</ul>

<p>{des2:9}
Symbols and networks connections are objects that contribute to the
abstract, logical meaning of the sheet (components and networks). A
decoration is a graphical element that is displayed and edited and
exported on graphical output formats, but does not contribute to the
logical meaning on a computer-readable level.

<p>{des2:12}
On graphical schematic sheets, many non-decoration objects are realized
using graphical drawing primitives:
<ul>
	<li> in-sheet networks can be specified by drawing lines/arcs/etc. that form a wire-net
	<li> hubs splitting and connecting different networks
	<li> in-sheet bundled networks, by drawing lines/arcs/etc. that form a bus-net
	<li> inter-sheet networks or buses, by drawing ports or bus-ports
	<li> components, by placing the graphical representation of symbols
	<li> in-sheet network connection to an in-sheet component by connecting a wire-net to a port of the symbol
</ul>

<h3> 2.3.1. graphical representation of wires </h2>

<p>{des2:13} <a id="des2:13">
A wire-net is a group of <a href="03_drawing.html#role_wire_net">drawing
primitives</a> (e.g lines). In this chapter these drawing primitives are called wire-segments.  The
group is tagged to be a wire-net by its role attribute. The graphical
representation of a wire-net does not need to be a straight line, but
can be a graph that even includes cycles. In other words, a wire-net can
be drawn as many lines with junctions and loops.

<p id="des2:81">{des2:81}
A junction is graphics within a wire-net that represents connected crossings
of wires between wire objects of the same wire-nt. The simplest junction is
a zero-length line drawn with a pen thicker than wires. Any other junction
graphic is drawn packing atoms in a group or group_ref with role=junction
within the wirenet.

<p>{des2:14}
A wire-net can be connected to zero or more ports or bus-ports. A
wire-net can not leave the current sheet - there are no inter-sheet wire-segments.

<p>{des2:15}
A wire-net always represents (a part of) a network. In the simplest case a wire-net
is a network. In more complex cases multiple wire-nets (potentially on multiple
schematics sheets) and/or non-graphical data (e.g. connection dictated by
attributes or non-graphical schematics data) build a single network.


<p>{des2:16}
A wire-segment has no attributes of its own, only a wire-net has. The attributes
of a wire-net contributes to the attributes of the network it is part of. (The
details of this will be discussed in a later chapter; TODO: link). Therefore
there are always two things to consider, present or edit:
<ul>
	<li> the attributes of a given wire-net (the <i>concrete</i> model's attributes)
	<li> the cumulative attributes of the network the given wire-net is part of (the <i>abstract</i> model's attributes)
</ul>

<p>{des2:17}
The set of possible attributes of a wire-net is the same as the attributes of a network
(see below).

<h3> 2.3.2. graphical representation of hubs </h2>

<p>{des2:57} <a id="des2:57">
A hub-point is a concrete object (sometimes graphically represented as a
largish dot or polygon). One or more different wire-nets can be connected to a
hub-point; these wire-nets will be kept as separate networks, the
hub-point won't merge them.

<p>{des2:58}
A hub-point also has attributes.

<p>{des2:59}
The concrete hub-point is translated into an abstract hub for the abstract
model.

<p>{des2:60}
Hub-points can connect bus-nets too.

<p>{des2:61}
A hub-point differs from a normal wire-net branching in that:
<ul>
	<li> it allows multiple wire-nets be connected without merging them, whithout forcing them to contribute to the same abstract network (in other words, keeping them separate nets)
	<li> it is an explicit object that has identifiers, can be referenced and can show up in the output
	<li> it can have attributes
</ul>

<h3> 2.3.3. graphical representation of components and ports</h2>

<p>{des2:18} <a id="des2:18">
The graphical representation of (a part of) a component is called symbol.

<p>{des2:19}
A symbol is a <a href="03_drawing.html#des3:53"> group </a> or <a
href="03_drawing.html#des3:57">group_ref</a> with symbol-related
attributes. It typically contains furhter groups for terminals,
bus-terminals, other symbols and decoration. When a symbol is placed on
a schematic sheet (either by copy or by reference), it is
<i>instantiated</i>. A symbol has a creation-time cschem generated
unique ID (which is the uuid field of the symbol group).

<p>{des2:82}
Groups also have an src_uuid field, which is used to track original sources.
A newly created group has NIL (empty) src_uuid. Any copy of the group
(e.g. an instance of the a library symbol on a sheet) will have src_uuid
filled in with the src_uuid value of the source group, or if that was NIL,
with the "instance uuid" (the group's <i>uuid</i> field) of the source group.

<p>{des2:53}
When an existing instance is moved within the sheet, renamed, its
attributes changed, it retrains instance UID (<i>uuid</i> field). When the instance is
copied, the new copy is a new instantiaton and gets a new instance UID. In
both cases it retains its <i>src_uuid</i> field.

<p>{des2:20}
A symbol is usually part of a component, donating ports and attributes to
the abstract (logical) component. The simplest component is created by a single
symbol. More complex components are created by a combination of multiple
symbols placed on graphical schematics sheets (and potentially be generated by
non-graphical schematics sheets). Attribute collisions are resolved
<a href="04_attrib#des4:24">the standard way.</a>

<p>{des2:21}
Among the attributes of symbols instance is one called <i>name</i>, which is
the project-unique identifier of the component the symbol instance contributes
to. <a href="02_data_imp.html#imp2:26">The refdes can be calculated</a> from this name,
see also: <a href="06_hierarchy.html"> hierarchy.</a>

<p>{des2:22}
A symbol can be marked being decoration, in which case it does not contribute
to any component.

<p>{des2:23}
A symbol can be used to describe a connection between different schematics
sheets, to represent (and reference to) a whole schematics sheet in a
<a href="06_hierarchy.html#des6:15">hierarchy</a>,
to represent a data file or other resource meaningful to specific plugins
(TODO: THIS CHAPTER).


<p>{des2:24} <a id="des2:24">
The graphical representation of an abstract port is called <i>terminal</i>. A 
(concrete) terminal is modelled as a line. A terminal hosts a list of attributes.

<p>{des2:25} <a id="des2:25">
Similar to port, the bus-port's representation is called <i>bus-terminal</i>,
it is also modeled as a line and hosts a list of attributes.


<p>{des2:76} <a id="des2:76">
Terminals and bus-terminals are most often part of symbols, but for
hierarchical designs they are also placed directly on sheets to serve as
an <a href="06_hierarchy.html#des6:20">interface to the parent.</a>

<h2> 2.4. <i>Concrete:</i> data/programmed schematics sheets </h2>

<p>{des2:26} A data/programmed schematics sheet is a non-graphical sheet.
The purpose of the data/programmed schematics sheet is the same as
the purpose of a graphical schematics sheet: to donate concrete source objects
for the abstract objects.

<p>{des2:71} The data/programmed schematics sheet contains data in a
format understood by one of the plugins in the current view. That plugin
is a "compiler" that interprets sheet data and emits abstract objects for
cschem to use. The compilation process can be as simple as parsing the
data or as complex as interpreting a high level programming language to
generate the abstract objects. Cschem doesn't impose any restriction on
the data format.

<p>{des2:72} For the GUI a data/programmed schematics sheet is usually
opaque data which can not be displayed or edited. Most often the data is
edited by external applications. Alternatively the plugin handling the
format may provide custom GUI.

<h2> 2.5. <i>Abstract:</i> details of schematics objects </h2>

<p>{des2:27} The abstract schematics consists only of a few object types. Their
parent-children relations are illustrated by the tree below:
<p><img src="02_abstract.svg">

<p>{des2:28}
The attributes of a symbol, terminal and bus-terminal are the same as the
attributes of a component, port or bus-port, respectively (see below).

<h3> 2.5.1. components and ports </h3>

<p>{des2:29}
A component is a project-global object that has:
<ul>
	<li> an unique ID (cschem generated)
	<li> a list of attributes
	<li> zero or more ports
	<li> zero or more bus-ports
</ul>

<p>{des2:30}
A port is a point of connect owned by a component. A port can connect a
component to a network.

<p>{des2:31}
A port is a component-local object that is created by a graphical symbol
(from a graphical sheet) or from data/program (from a data sheet).

<p>{des2:32}
A port has:
<ul>
	<li> a cschem generated unique ID
	<li> a list of attributes
	<li> on that list, an attribute called <i>name</i> which is an unique ID of the port within the component
</ul>

<p>{des2:33}
If there are multiple terminals with the same <i>name</i> within the same
component (within one or multiple symbols; specified graphically or via
data), they are combined into a single port with their attributes also
combined, with the usual
<a href="04_attrib#des4:24">attribute collision rules</a>.

<p>{des2:77} <a id="des2:77">
The terminal-&gt;port name translation can be done by plugins; when
available, core will call plugins for this job. This allows slotting
implemented in plugins: the same terminal name in different slots may
mean different ports within the same component.

<p>{des2:34}
A bus-port is a port with multiple "parallel" channels, each channel
modelled as a separate port, called channel-port. A channel-port has a
<i>chan</i> attribute that specifies which network the given <i>chan</i>
will try to connect to when a bus-net or wire-net is connected to the
bus-port.

<p><b>{des2:35}
<a href="06_hierarchy.html#des6:8">
Note: details on addressing networks by name is in a later chapter</a></b>

<p id="des2:55">{des2:55}
Abstract network <i>name</i> attributes are donated directly by the
concrete wire-nets contributing <i>name</i> attributes. (In case of
hierarchy the name might be
<a href="06_hierarchy.html#des6:27">translated/calculated by a plugin</a>).

<p><table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:36} core attributes of a component
<tr><th> attribute <th> value          <th> description
<tr><td> uuid      <td> unique ID      <td> cschem-generated UID (not persistent)
<tr><td> connect   <td> PORT:NET list  <td> non-graphical connection; PORT is an existing port's <i>name</i> within the component; NET is the <i>name</i> of a network
<tr><td> source    <td> list of refs   <td> reference list to the concrete objects that contributed to this component; when saved: each item is an UID or an UID:key pair
</table>

<p><table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:37}<a id="des2:37"> core attributes of a port
<tr><th> attribute <th> value           <th> description
<tr><td> uuid      <td> unique ID       <td> cschem-generated UID
<tr><td> name      <td> name of the port<td> user assigned port name
<tr><td> connect   <td> name of a network<td> the given port is also connected to a network (non-graphical connection)
<tr><td> chan      <td> channel name    <td> connection affinity, in case port is part of a bus-port
<tr><td> chan_rewrite<td> rewrite list  <td> see at <a href="#des2:78">chan rewrite</a>
</table>

<p><table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:38} core attributes of a bus-port
<tr><th> attribute <th> value           <th> description
<tr><td> uuid      <td> unique ID       <td> cschem-generated UID
<tr><td> name      <td> name of the port<td> user assigned port name
<tr><td> connect   <td> name of a bus-net<td> the given bus-port is also connected to a named bus (non-graphical connection)
<tr><td> chan_rewrite<td> rewrite list  <td> see at <a href="#des2:78">chan rewrite</a>
</table>


<h3> 2.5.2. networks </h3>

<p>{des2:40}
A network is:
<ul>
	<li> a list of ports connected (derived from contributors: explicit graphical wire-nets or implicit connections through attributes)
	<li> a list of attributes (combined from the attributes of the same contributors)
</ul>

<p>{des2:41}
A network has a project-wise unique name <i>netname</i>, which is derived
from the user specified <i>name</i> attribute and other factors (e.g.
hierarchy). A network also has a cschem generated unique ID.

<p>{des2:42}
A network is combined from:
<ul>
	<li> explicit graphical wiring: wire-nets and channels of bus-nets
	<li> implicit connections: attributes specified in components or ports or bus channels
	<li> connections dictated by data schematics sheets
</ul>

<table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:43} core attributes of a network
<tr><th> attribute <th> value          <th> description
<tr><td> uuid      <td> unique ID      <td> cschem-generated UID
<tr><td> netname   <td> unique name    <td> cschem-specified project-unique network name
<tr><td> name      <td> unique name    <td> user-specified sheet-unique network name
<tr><td> chan      <td> bus-unique name<td> when a connection is made, this name is used to look up and bind channel(s)
<tr><td> source    <td> list of refs   <td> reference list to the concrete objects that contributed to this component; when saved: each item is an UID or an UID:key pair
</table>


<h3> 2.5.3. bundled networks: buses and bus-ports </h3>

<p>{des2:44}
A bus-net is a <b>logical</b> bundling of multiple networks.

<p>{des2:45}<a id="des2:45">
A bus-net consists of 1 or more bus-channels. Each bus-channel behaves as a network in
all regards. Each bus-channel has a <i>chan</i> attribute that specifies
what network or channel the given bus-channel will try to connect to when
the bus-net as a whole is connected.

<p>{des2:46}
If a network is connected to the bus-net, either graphically or by attributes
or data schematics, the network is connected to the bus-channel that has the
<i>chan</i> attribute that matches the network's <i>chan</i> or <i>name</i> attribute.

<p>{des2:47}
If a port is connected to a bus-net directly, the port must specify a <i>chan</i>
attribute. The port is connected to the bus-channel that has matching name
(<i>chan</i> attribute), considering <a href="#des2:78">the chan rewrite</a>
attribute of the port. If there is no match, no connection is made.

<p>{des2:48}
If a bus-port is connected to a bus-net directly, a matching is performed
between the bus-port's <i>chan</i> attributes and the
bus-channels' <i>chan</i> attributes, considering <a href="#des2:78">the
chan rewrite</a> attribute of the bus-port. Whenever a match is found, a
connection is made. (Hint: the number of connection made should be
indicated by the UI so 0 connection is easy to detect)

<p>{des2:49}
If a network is connected to a bus-port, the same rules apply as if
the network was connected to a bus-net, plus the bus-port's
<a href="#des2:78">chan rewrite</a> attribute is considered.

<p>{des2:50}
A bus-port accepts multiple bus-net connections and multiple network
connections. In case of multiple network connections, networks with
different net attributes are not connected together just because they are all
connected to the same bus-port. In other words, the channels of the
bus-port act as an independent port and each network will interact only
with the channel of the same net attribute, but channels are independent.
The connections are made on per-channel basis, considering
<a href="#des2:78">the chan rewrite</a> attribute of the bus-port.

<p><table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:51} core attributes of a bus-net
<tr><th> attribute <th> value          <th> description
<tr><td> uuid      <td> unique ID      <td> cschem-generated UID
<tr><td> name      <td> unique name    <td> user-specified unique bus-net name
<tr><td> source    <td> list of refs   <td> reference list to the concrete objects that contributed to this component; when saved: each item is an UID or an UID:key pair
</table>

<h3> 2.5.4. hubs </h3>

<p>{des2:62}
A hub is an explicit object that forms a connection between multiple
different networks or buses (or in an extreme case is connected to
a single network or bus).

<p>{des2:63}
On an output (e.g. netlist) that supports this feature, a hub is presented
as an explicit object. On output where this feature is not available, the
connected networks have to be merged.

<p>{des2:64}
A hub can be regarded as a component with as many ports as many networks are
connected to it. It represents a physical galvanic connection among all
networks connected.

<p>{des2:65}
A hub can be regarded as a component with as many bus-ports as many bus-nets are
connected to it. It represents a physical galvanic connection among all bus
channels with matching name, considering <a href="#des2:78">the chan rewrite</a>
attribute of the hub.

<p>{des2:66}
If a hub has at least one bus connection, it will do all bindings based on
chan matching, considering <a href="#des2:78">the chan rewrite</a>
attribute of the hub. This applies to all channels of all buses connected
and to the chan attribute of all networks connected. If a network connected
to such a bus does not have a chan attribute even after the <i>chan rewrite</i>,
it is left unconnected.


<p><table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:67} core attributes of a hub
<tr><th> attribute <th> value          <th> description
<tr><td> uuid      <td> unique ID      <td> cschem-generated UID
<tr><td> name      <td> unique name    <td> user-specified unique hub name (similar to a component's name)
<tr><td> source    <td> list of refs   <td> reference list to the concrete objects that contributed to this component; when saved: each item is an UID or an UID:key pair
<tr><td> chan_rewrite<td> rewrite list <td> see at <a href="#des2:78">chan rewrite</a>
</table>

<h3> 2.5.5. connecting networks and ports </h3>

<p><table border=1 cellspacing=0>
<tr><th colspan=6 bgcolor="#aaaaaa"> {des2:52} connectivity matrix
<tr><td> &nbsp;  <td> wire-net<td> port   <td> hub    <td> bus-net<td> bus-port
<tr><td> wire-net<td> direct  <td> direct <td> direct <td> 1chan <td> 1chan
<tr><td> port    <td> direct  <td> direct <td> invalid<td> 1chan <td> 1chan
<tr><td> hub     <td> direct  <td> invalid<td> invalid<td> match <td> invalid
<tr><td> bus-net <td> 1chan   <td> 1chan  <td> match  <td> match <td> match
<tr><td> bus-port<td> 1chan   <td> 1chan  <td> invalid<td> match <td> match


<tr><th colspan=6"> &nbsp;<br>&nbsp;<br>
<tr><th colspan=6 bgcolor="#aaaaaa"> connection types
<tr><th> direct <td colspan=5> 1:1 connection ("knob", "node")
<tr><th> 1chan  <td colspan=5> single port or network connected to one of the channels by the <i>chan</i> attribute, if the chan is found in the bus-net or bus-port
<tr><th> match  <td colspan=5> channel list matching; matching channels are connected, considering <a href="#des2:78">the chan rewrite</a> attribute of the hub or port or bus-port.
<tr><th> invalid<td colspan=5> connection can not be made
</table>

<h3> 2.5.6. chan rewrite </h3>

<p id="des2:78">{des2:78}
The purpose of chan[nel] rewrite is to provide a mechanism that hubs and
ports can control how they connect bus channels. The normal mechanism
is full name match: e.g. if two buses are connected, the channels with
matching names are connected. This happens if the chan rewrite list of
the connection point is empty - in the simple, default case.

<p>{des2:79}
To allow <i>pseudo-bus-hierarchy</i>, the <i>chan_rewrite</i> attribute
can rename chan attributes for the connection lookup. The rewrite affects
only the code that performs the chan name matching, it has no effect
outside of that domain.

<p>{des2:80}
The <i>chan_rewrite</i> attribute is an unordered list of rules. A rule is
a <i>name::pattern::subs</i> triplet. Any incoming connection
(networks or buses) are searched. If their <i>name</i> attribute matches the
<i>name</i> field in the rule, the rule is executed: the 
regex [TODO: link to appendix for the syntax] <i>pattern</i> is matched against
the chan attribute of the network or bus, and the matching portion is substituted
with the <i>subs</i> string of the rule.


<h3> 2.6. glossary </h3>

<p><table border=1 cellspacing=0>
<tr><th colspan=3 bgcolor="#aaaaaa"> {des2:70}<a id="des2:70"> glossary
<tr><th> term    <th> context  <th> meaning
<tr><td> abstract model
	               <td> project-view<td> an in-memory model of the circuit as rendered by the plugins from the concrete objects; has no graphical representation; not edited by the user
<tr><td> attribute
	               <td> any      <td> a textual key=value pair attached to any object in cschem
<tr><td> bus
	               <td> abstract <td> a construct that allows multiple channels (local nets) bundled
<tr><td> bus-channel
	               <td> abstract <td> == channel (in the context of buses: shorthand for "a channel of a bus")
<tr><td> bus-net
	               <td> concrete <td> graphical representation of multiple bus-segments connected (may have junctions)
<tr><td> bus-segment
	               <td> (drawing primitives) <td> graphical representation of a segment of a bus (drawn using drawing primitives)
<tr><td> bus-port
	               <td> abstract <td> a component port where a bus can be connected; behaves like a group of ports
<tr><td> bus-terminal
	               <td> concrete <td> a terminal ("pin") of a symbol that accepts bus connection; allows multiple channels as if it was a bunch of bundled terminals
<tr><td> channel
	               <td> abstract <td> a named "wire" of a bus or bus-port
<tr><td> channel-port
	               <td> abstract <td> each channel of a bus-port behaves similar to a port; these are called channel-ports
<tr><td> component
	               <td> abstract <td> an atomic device
<tr><td> concrete model
	               <td> project  <td> the data model edited by the user; used as a source for the abstract model
<tr><td> hub
	               <td> abstract <td> an object that connects multiple networks without making them one network; can be used to split a (former) network into two (new) separate networks
<tr><td> hub-point
	               <td> concrete <td> the graphical representation of a hub (drawing primitive)
<tr><td> junction
	               <td> concrete <td> anonymous junction on a wire-net or bus-net, connecting two or more wire-segments or bus-segments
<tr><td> network
	               <td> abstract <td> a named circuit network: a list of ports connected
<tr><td> port
	               <td> abstract <td> a component's point-of-connect to a network (e.g. a pin or pad)
<tr><td> project-view
	               <td> top-level<td> a specific view of a specific project
<tr><td> symbol
	               <td> concrete <td> schematics symbol that represents (a part of) an element
<tr><td> terminal
	               <td> concrete <td> a "pin" of a symbol that accepts a network connection
<tr><td> uid,<br>uuid,<br>(universally/globally) unique ID
	               <td> any      <td> globally unique identifier - a series of random-looking bytes
<tr><td> wire-net
	               <td> concrete <td> graphical representation of multiple wire-segments connected (may have junctions)
<tr><td> wire-segment
	               <td> (drawing primitives) <td> graphical representation of a segment of a wire (drawn using drawing primitives)
</table>
